#
# Overflow :: Generic Game Network Class (GameNet)
# by Team Soya (see AUTHORS)
#
# Copyright (C) 2005 Arc Riley
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
#

from time import time, sleep

from network import *
          
class GameNet(GenNet) :
  def __init__(self, parent=None) :
    GenNet.__init__(self, parent)
    self.sock = None
    self.nick = ''
    self.buff = {}
    self.activ = 0
    self.state = 0

  def bind(self) :
    try :
      self.sock.bind(('0.0.0.0', self.port))
      self.sock.setblocking(0)
      return True
    except socket.error :
      self.error = 'Couldn\'t bind UDP socket'
      return False

  def connect(self) :
    sock = GenNet.connect(self, socket.SOCK_DGRAM)
    if not sock : 
      return False
    for port in xrange(20294, 24390) :
      self.port = port
      if self.bind() :
        break
    print 'I AM ON LOCAL PORT %d' % self.port
    self.sock.sendto('.', ('72.43.24.246', 1010))
    timeout = time() + 5.0
    while time() < timeout :
      sleep(.1)
      try :
        recv = self.sock.recvfrom(1024)
      except socket.error: 
        continue
      if recv[1] != ('72.43.24.246', 1010) :
        continue
      recv = recv[0].split()
      try :
        self.port = int(recv[1])
        print 'I AM ON OUTSIDE PORT %d' % self.port
        break
      except :
        break

    self.activ = 0
    self.state = 1
    return True

  def send(self, message, address) :
    print 'sending %s to %s' % (message, address)
    if not self.sock :
      print 'no self.sock??????????????????????????????????????????????'
      self.reset()
      return False
    if self.buff.has_key(address) :
      message = '%s%s\n' % (self.buff[address][0], message)
    else :
      message = '%s\n' % message 
    try :
      sent = self.sock.sendto(message, address)
    except socket.error :
      return False
    if self.buff.has_key(address) :
      self.buff[address][0] = message[sent:]
      print self.buff[address][0]
    return True

  def recv(self) :
    if not self.sock :
      print 'recv: no self.sock??????????????????????????????????'
      self.reset()
      return False
    try : 
      recv = self.sock.recvfrom(1024)
      address = recv[1]
      recv = recv[0]
      print 'received %s from %s' % (recv, address)
      if self.buff.has_key(address) :
        print 'WE KNOW THIS PERSON!'
        self.buff[address][1] += recv
        buff = self.buff[address][1]
      else :
        print 'WE --dont-- KNOW THIS PERSON!'
        buff = recv
    except socket.error :
      buff = ''
    newline = buff.find('\n')
    if newline != -1 :
      print 'NEWLINE!'
      line = buff[:newline]
      # keep the rest if it's "connected", otherwise ignore remainder
      if self.buff.has_key(address) :
        self.buff[address][1] = self.buff[address][1][newline+1:]
      return (line, address)
    else :
      if buff :
        print 'NO NEWLINE!', buff
      return None

