import soya
import utils
from soya.sdlconst import *

#
# This controller class processes both keyboard and mouse input.
# Escape opens a "game menu" with option to quit, Function keys do their 
# things, left and right keys rotate which polygon side the player is 
# facing, up moves to the polygon they're facing, down drops a charge.
# 
# Clicking left mouse button on a polygon moves them toward that 
# polygon, right click or shift-click drops a charge on a polygon, 
# middle click or ctrl-click throws a "charge ball" to that polygon.
#
# All other keyboard input is for the chat window. 
#

# XXX d1223m says:
# whats going on here?
# pudding can handle input much nicer than this 
# 
# for chat window its possible to accept all keyboard input with "focus"
#
# single mouse button click code is nice but again can be moved to 
# pudding style stuff 

class GameController:
  def __init__(self):
    self.held_keys   = {}		# Keys that are being held down
    self.target_poly = 0		# The polygon it's moving to now
    self.destin_poly = 0		# Where it's trying to move to
    self.drop_charge = False		# Drop a charge at destin_poly?
    self.action_keys = {
      K_ESCAPE      = sys.exit,
      K_F10         = soya.toggle_wireframe,
      K_F12         = utils.screenshot,
      BUTTON_LEFT   = self.lclick,
      BUTTON_MIDDLE = self.mclick, 
      BUTTON_RIGHT  = self.rclick }

    self.chat_keys = {
      K_a = ('a', 'A', None),
      K_b = ('b', 'B', None),
      K_c = ('c', 'C', None),
      K_d = ('d', 'D', None),
      K_e = ('e', 'E', None),
      K_f = ('f', 'F', None),
      K_g = ('g', 'g', None),
      K_h = ('h', 'H', None),
      K_i = ('i', 'I', None),
      K_j = ('j', 'J', None),
      K_k = ('k', 'K', None),
      K_l = ('l', 'L', None),
      K_m = ('m', 'M', None),
      K_n = ('n', 'N', None),
      K_o = ('o', 'O', None),
      K_p = ('p', 'P', None),
      K_q = ('q', 'Q', None),
      K_r = ('r', 'R', None),
      K_s = ('s', 'S', None),
      K_t = ('t', 'T', None),
      K_u = ('u', 'U', None),
      K_v = ('v', 'V', None),
      K_w = ('w', 'W', None),
      K_x = ('x', 'X', None),
      K_y = ('y', 'Y', None),
      K_z = ('z', 'Z', None),
      K_1 = ('1', '!', None),
      K_2 = ('2', '@', None),
      K_3 = ('3', '#', None),
      K_4 = ('4', '$', None),
      K_5 = ('5', '%', None),
      K_6 = ('6', '^', None),
      K_7 = ('7', '&', None),
      K_8 = ('8', '*', None),
      K_9 = ('9', '(', None),
      K_0 = ('0', ')', None) }

  def lclick(self):
    if self.held_keys.has_key(K_LCTRL) or 
       self.held_keys.has_key(K_RCTRL) :
      self.mclick()
      return
    if self.held_keys.has_key(K_LSHIFT) or 
       self.held_keys.has_key(K_RSHIFT) :
      self.rclick()
      return
    # Check to see if the mouse is over a polygon

  def mclick(self):
    # Check to see if the mouse is over a polygon
    pass

  def rclick(self):
    # Check to see if the mouse is over a polygon
    pass


