import soya

import states

class BasePromptState(states.ApplicationState):
  """ state used for prompts which halt the application

    >>> state = states.BasePromptState(self)
    >>> self.application.set_state(state, stack = True)

    remember to clean up widgets before stopping!

  """
      
  def __init__(self, last_state):
    self.application = last_state.application
    self.root_widget = last_state.root_widget
    self.scene = last_state.scene

    soya.Idler.__init__(self, self.scene)

  def stop(self):
    self.application.pop_state()
  
  def begin_round(self):
    pass 
