import sys

import soya
from soya import pudding

# XXX what is wrong with using pudding.idler.Idler ???
#from pudding.idler import Idler as BaseIdler
# XXX temporarily use this 
from soya import Idler as BaseIdler

from soya import sdlconst as sdl

import utils
import widgets

def global_event_hook(event):
  """ global event processing. """
  if event[0] == sdl.KEYDOWN:
    if event[1] == sdl.K_F12:
      utils.screenshot()
      return True

    elif event[1] == sdl.K_F11:
      sys.exit()
      return True

    elif event[1] == sdl.K_F10:
      soya.toggle_wireframe()
      return True

  return False

def process_event():
  """ modified version of pudding.process event to allow for global
  event hook """

  events = soya.process_event()
  unused_events = []

  for event in events:
    if (not soya.root_widget.process_event(event) 
        and not global_event_hook(event)):
      unused_events.append(event)

  return unused_events
      

class ApplicationState(BaseIdler):
  """ Base class for an application state """
  ROOT_WIDGET_CLASS = widgets.RootWidget
  MUSIC = 'music/His_Spirit_Remix.ogg'
  
  def __init__(self, application):
    self.application = application
    
    self.setup_scene()

    self.game_events = []

    BaseIdler.__init__(self, self.scene)

  def setup_scene(self):
    """ create the scene object and populate it. 
    create the camera object and setup the root widget """

    self.scene = soya.World()

    self.camera = soya.Camera(self.scene)
    
    self.root_widget = self.ROOT_WIDGET_CLASS(self)
    self.root_widget.add_child(self.camera)

    self.logo = widgets.Logo(self.root_widget)

    soya.set_root_widget(self.root_widget)

    self.root_widget.on_resize()
  
  def start(self):
    """ start the idler """
    self.root_widget.on_resize()

    # XXX XXX ???
    self.next_round_tasks.append(self.root_widget.on_resize)

    self.application.play_music(self.MUSIC)

    self.idle()

  def try_exit(self):
    """ a user triggered request to exit the current state """
    pass

  def begin_round(self):
    # XXX should be using pudding.idler
    BaseIdler.begin_round(self)
    self.game_events = process_event()

    # XXX dont think we need this with new Rootwidget
    #self.process_game_events()

  def process_game_events(self):
    for event in self.game_events:
      if event[0] == sdl.KEYDOWN:
        if event[1] == sdl.K_ESCAPE:
          self.try_exit()
 
