import soya
from soya import pudding

import states
import widgets

class YesNoPromptState(states.BasePromptState):
  def __init__(self, last_state, text):
    states.BasePromptState.__init__(self, last_state)

    self.value = False

    self.panel = pudding.control.Panel(self.root_widget,
                                        left = 10, 
                                        top = 10, 
                                        width = 300,
                                        height = 200,
                                        )
    
    self.container = pudding.core.Container(self.panel,
                                        left = 0,
                                        top = 0,
                                        right = 0,
                                        bottom = 0,
                                        )
    
    self.label = pudding.control.Label(self.container,
                                        left = 10,
                                        top = 10, 
                                        right = 10,
                                        bottom = 10,
                                        label = text)

    self.yes_but = widgets.ImageButton(self.container,
                                        height = 40,
                                        width = 40,
                                        material = soya.Material.get('new'),
                                        func = self.no,
                                        )
    self.yes_but.set_pos_bottom_right(bottom = 10, right = 50)
                                  
    self.no_but = widgets.ImageButton(self.container,
                                        height = 40,
                                        width = 40,
                                        material = soya.Material.get('new'),
                                        func = self.yes,
                                        )
    self.no_but.set_pos_bottom_right(bottom = 10, right = 110)

  def begin_round(self):
    self.game_events = []
    self.panel.begin_round()

  def stop(self):
    self.root_widget.children.remove(self.panel)
    states.BasePromptState.stop(self)
  
  def yes(self):
    self.value = True
    self.stop()

  def no(self):
    self.value = False
    self.stop()

                                        

